// Programacin en C++ para Ingenieros, Ed. Thomson Paraninfo, 2006
// Captulo 8: Diseo descendente

// Ejemplo: El museo
// fichero: ElMuseo.cpp

//Nmero mximo de piezas
const int PIEZAS = 2000;
//Nmero mximo de pabellones
const int PABELLONES = 10;

//Nmero mximo de autores
const int AUTORES = 1000;

//Nmero mximo para la tabla de caracteres,
//30 posiciones segn el enunciado del problema
//y una ms para el centinela.
//Total 31
const int L = 31;

//Tipo enumerado para los distintos temas de
//los cuales el museo expone piezas.
enum tTema {barroco, renacentista, medieval};

//Tabla para guardar el nombre.
typedef char tCadena[L];

//Tupla para la fecha de nacimiento y defuncin
//del autor
struct tFecha{
    int dia,mes,anyo;
};

//Tupla para las medidas de las piezas.
struct tMedidas{
    float alto, ancho;
};

//Tupla para los datos del pabelln.
struct tPabellon{
    int codigo, numSalas;
    tCadena nombre;
    tTema tema;
};

//Tupla para la informacin de la pieza.
//El campo dniAutor permite relacionar a una
//pieza con los datos de su autor a travs del campo
//dniAutor en la estructura de datos que guarda la informacin
//de todos los autores: tListaAutores (vase ms abajo).
struct tPieza{
    int codigo;
    tCadena nombre;
    float valor;
    long dniAutor;
    tMedidas medidas;
    tTema tema;
    bool original;
};

//Tupla para la informacin del autor.
//El campo dni permite relacionar a un
//autor con todas sus piezas a travs de campo dniAutor
//la estructura de datos que guarda la informacin
//de todos las piezas: tListaPiezas (vase ms abajo)
struct tAutor{
    long dni;
    tCadena nombre;
    tCadena nacionalidad;
    int numPiezas;
    tFecha fecNacimiento;
    tFecha fecDefuncion;
};

//Tabla para la informacin de todas las piezas
//expuestas en el museo
typedef tPieza tListaPiezas[PIEZAS];

//Tupla que almacena las piezas
//expuestas en el museo
//piezas contiene la lista y
//numPiezas el nmero de
//posiciones ocupadas
struct tPiezas{
    tListaPiezas piezas;
    int numPiezas;
};

//Tabla para la informacin de todos los autores
//que exponen en el museo.
typedef tAutor tListaAutores[AUTORES];

//Tupla que almacena los
//datos de los autores que
//exponen en el museo
struct tAutores{
    tListaAutores autores;
    int numAutores;
};

//Tabla para la informacin de todos los pabellones
//del museo. Esta tabla no forma parte de una tupla
//como pasa con autores o piezas porque en el enunciado
//del problema se dice que hay 20 y que aunque no sea
//de forma explcita se considera que todos tienen datos.
typedef tPabellon tListaPabellones[PABELLONES];

//Tupla para guardar toda la informacin, es decir,
//pabellones, piezas y autores
struct tMuseo{
    tListaPabellones pabellones;
    tPiezas piezas;
    tAutores autores;
};
