// Programacin en C++ para Ingenieros, Ed. Thomson Paraninfo, 2006
// Captulo 8: Diseo descendente

// Fichero complejo.h
// Declaracin de la clase complejo

// Por si este fichero estuviera definido
// lo controlamos con estas directivas
#ifndef MI_COMPLEJO_H
    #define MI_COMPLEJO_H

    #include <iostream>

    using namespace std;

    class Complejo{
        private:
            double real,imag;
        public:
            Complejo();

            // Constructor general
            Complejo(double, double);

            // Constructor de copia
            Complejo(const Complejo&);

            // Mtodo para modificar la parte real
            void setReal(double);

            // Mtodo para modificar la parte imaginaria
            void setImag(double);

            // Mtodo para devolver la parte real
            double getReal();

            // Mtodo para devolver la parte imaginaria
            double getImag();

            // Mtodo para el clculo del conjugado de un
            //complejo
            Complejo conjugado();

            // Mtodos para la representacin polar:
            // Clculo del mdulo de un complejo
            double modulo();
            // Mtodo para el clculo del argumento de
            // un complejo
            double angulo();

            // Mtodo para el clculo del inverso de un complejo
            Complejo inverso();

            // Operadores miembro sobrecargados
            Complejo operator- ();
            Complejo operator+ (const Complejo& c);
            Complejo operator- (const Complejo& c);
            Complejo operator* (const Complejo& c);
            Complejo operator/ (const Complejo& c);

            // Operador miembro de asignacin sobrecargado
            Complejo& operator= (const Complejo& c);

            // Operador friend de test de igualdad sobrecargado
            friend bool operator== (const Complejo& c1,const Complejo& c2);

            // Operador friend de test de desigualdad sobrecargado
            friend bool operator!= (const Complejo& c1,const Complejo& c2);

            // Operador friend << sobrecargado
            friend ostream& operator<< (ostream& co, const Complejo& c);

            // Operador friend >> sobrecargado
            friend istream& operator>> (istream& ci, Complejo& c);
    };
#endif
